import json
import re
import urllib.request  # import urllib 报错: module 'urllib' has no attribute 'request'
import os
import setuptools

name = "goodow-dataflow"


def version():
  if 'GITHUB_CONTEXT' in os.environ:
    github = json.loads(os.environ['GITHUB_CONTEXT'])
    ref: str = github['event']['ref']
    if ref.startswith('refs/tags/v'):
      return ref[len('refs/tags/v'):]

  # process = subprocess.run(
  #     ['git', 'rev-parse', '--short', os.environ['GITHUB_SHA']],
  #     capture_output=True,
  #     text=True)
  # short_sha = process.stdout.strip()
  resp = urllib.request.urlopen(f'https://test.pypi.org/pypi/{name}/json')
  data = json.loads(resp.read().decode("utf-8"))
  version = data['info']['version']
  last_num = re.findall(r'\d+', version)[-1]
  version = version[:-len(last_num)] + str(int(last_num) + 1)
  return version


setuptools.setup(
    name=("%s" % name),
    # version="0.0.1dev0",
    version=f"{version()}",
    author="Larry Tin",
    author_email="dev@goodow.com",
    description="A small example package",
    long_description='',
    url="https://github.com/goodow/goodow-dataflow",
    packages=setuptools.find_namespace_packages(
        where='../..',
        include=[
            'goodow.observability*', 'goodow.dataflow.feeds',
            'goodow.dataflow.feeds.elasticsearch'
        ],
        exclude=['goodow.dataflow.feeds.hdf_writer']),
    package_dir={"": "../.."},
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ],
    python_requires='>=3.6',
)
